<?php
/*
 * $Horde: imp/filter.php,v 1.0 2000/11/12 08:45:49 max Exp $
 *
 * Copyright 2000 Charles J. Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

require_once './lib/base.php';
require_once '../lib/Registry.php';

$registry = new Registry();

/* retrieve authentication information from session */
session_name($horde['session_name']);
@session_start();

if (!isset($imp) || !is_array($imp)) {
    header('Location: ' . Horde::url('login.php?reason=logout', true));
    exit;
}
IMP::setupSession();
IMP::authenticate(OP_HALFOPEN);

/* redirect back to the mailbox if folder use is not allowed */
if (!($conf['user']['allow_folders'])) {
    header('Location: ' . Horde::url('mailbox.php?', true));
    exit;
}

$preamble = preambleString();
$errormsg = '';

/* Run through the action handlers */
if (isset($actionID)) {
    switch ($actionID) {
        
    case NO_ACTION:
        break;
        
    case FILTER_CREATE:
        if(isset($field) && isset($text) && isset($action)) {
            $filters = @unserialize($prefs->getValue('filters'));
            if($action == 'move' && isset($folder)) {
                $filters[] = array('field' => $field, 'text' => $text, 'action' => 'move', 'folder' => $folder);
            }
            else if($action == 'delete') {
                $filters[] = array('field' => $field, 'text' => $text, 'action' => 'delete');
            }

            $prefs->setValue('filters', serialize($filters));
            $prefs->store();
        }
        break;

    case FILTER_DELETE:
        if(isset($number)) {
            $filters = @unserialize($prefs->getValue('filters'));
            array_splice($filters, $number, 1);
            $prefs->setValue('filters', serialize($filters));
            $prefs->store();
        }
        break;

    case FILTER_DOWN:
        if(isset($number)) {
            $filters = @unserialize($prefs->getValue('filters'));
            if($number < count($filters) - 1) {
                $tmpFilter = array_splice($filters, $number, 1);
                array_splice($filters, $number + 1, 0, $tmpFilter);
                $prefs->setValue('filters', serialize($filters));
                $prefs->store();
            }
        }
        break;

    case FILTER_UP:
        if(isset($number)) {
            $filters = @unserialize($prefs->getValue('filters'));
            if($number) {
                $tmpFilter = array_splice($filters, $number, 1);
                array_splice($filters, $number - 1, 0, $tmpFilter);
                $prefs->setValue('filters', serialize($filters));
                $prefs->store();
            }
        }
        break;

    } // switch
} // isset($actionID)

$title = _("Mail Filters");

require $conf['paths']['templates'] . '/doctype.inc';
require $conf['paths']['templates'] . '/common-header.inc';
require './menu.php';

$options = IMP::flistSelect('', false, array('INBOX'));
$filters = @unserialize($prefs->getValue('filters'));

require $conf['paths']['templates'] . '/filters/list.inc';
require $conf['paths']['templates'] . '/filters/create.inc';

require $conf['paths']['templates'] . '/common-footer.inc';

if ($conf['user']['online_help'] && $browser->js) {
    Help::javascript();
}
$registry->shutdown();
$prefs->store();

?>
